//+------------------------------------------------------------------+
//|                                                        cross.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Copyright  2011, G.Aldonis"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red 
#property indicator_color2 Blue


#property indicator_width1 0
#property indicator_width2 0


//Indicators
extern int TF=0;

extern int FastMAPeriod = 55;
extern int SlowMAPeriod = 144;
// extern int SignalMAPeriod = 55;

extern   int ma13per    =13;
extern   int ma55per    =55;
extern   int cciPer     =15;
extern   int cciPer1    =170;
extern   int point      =5;         
         
double B[];           
double S[];   

int maxperiod=0;

//-----------------------------------------------
int init() {
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexLabel(0,"Sell");
   SetIndexArrow(0, 234);
   SetIndexBuffer(0, S);
   
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexLabel(1,"Buy");
   SetIndexArrow(1, 233);
   SetIndexBuffer(1, B);


   if (FastMAPeriod > maxperiod) maxperiod=FastMAPeriod ;
   if (SlowMAPeriod > maxperiod) maxperiod=SlowMAPeriod ;
//   if (SignalMAPeriod > maxperiod) maxperiod=SignalMAPeriod ;
   if (ma13per > maxperiod) maxperiod=ma13per;
   if (ma55per > maxperiod) maxperiod=ma55per;
   if (cciPer > maxperiod) maxperiod=cciPer ;
   if (cciPer1 > maxperiod) maxperiod=cciPer1;


 
   return (0);
}
//------------------------------------------------
int deinit() { return (0); }
//-------------------------------------------------
int start() {
   int   i, limit;
   int   counted_bars = IndicatorCounted();   
   limit=Bars-counted_bars;
   if (limit>1) limit=Bars-maxperiod-5;

  
   for (i = limit; i >= 0; i--) {      
      int pos=i;
      if (TF>0)
         if (TF!=Period())
            pos=iBarShift(NULL, TF, Time[i]);
      double ma13_0=iMA(NULL,TF,ma13per,0,MODE_EMA,PRICE_CLOSE,pos+1);
      double ma13_1=iMA(NULL,TF,ma13per,0,MODE_EMA,PRICE_CLOSE,pos+2);      
      double ma55_0=iMA(NULL,TF,ma55per,0,MODE_EMA,PRICE_CLOSE,pos+1);
      double ma55_1=iMA(NULL,TF,ma55per,0,MODE_EMA,PRICE_CLOSE,pos+2);
          
      double cci15_0=iCCI(NULL,TF,cciPer,0,pos+1);
      
      double cci170_0=iCCI(NULL,TF,cciPer1,0,pos+1);
      
      double macd_0 = iMA(NULL, TF, FastMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+1) -
                iMA(NULL, TF, SlowMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+1);
      
      double macd_1 = iMA(NULL, TF, FastMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+2) -
                iMA(NULL, TF, SlowMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+2);
      
      double macd_2 = iMA(NULL, TF, FastMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+3) -
                iMA(NULL, TF, SlowMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+3);
      
      double macd_3 = iMA(NULL, TF, FastMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+4) -
                iMA(NULL, TF, SlowMAPeriod, 0, MODE_EMA, PRICE_CLOSE, pos+4);


      if((ma13_0-ma55_0)*(ma13_1-ma55_1)<0)  {
         if (ma13_0-ma55_0>0) {
            if (macd_0 >= macd_1 && macd_1 >= macd_2 && macd_2 >= macd_3 && cci15_0 >  50 && cci170_0 > 0 ) 
               S[i] = High[i]+point*Point; 
         } else {
            if (macd_0 <= macd_1 && macd_1 <= macd_2 && macd_2 <= macd_3 && cci15_0 < -50 && cci170_0 < 0 ) 
               B[i] = Low[i]-point*Point;
         }
      }
   }
   return (0);
}

